(function (lib, img, cjs) {

var p; // shortcut to reference prototypes

// stage content:
(lib.createjs_battle_sample = function(mode,startPosition,loop) {
	this.initialize(mode,startPosition,loop,{init:35,defence:46,attack:72,result:93},true);

	// timeline functions:
	this.frame_0 = function() {
		// バトルデータ
		// htmlからbattleDataとしてくる。
		// ターン数
		stage.turnNum = 0;  // 全体で使うので var しない。
		// 連打防止フラグ
		stage.isAnimate = false;  // 全体で使うので var しない。
		// ステータス反映
		for( var i = 0 ; i < 3 ; i++ ){
			var currentStatus = battleData.startStatus[ i ];
			var statusElement = this.TopIndex[ "OwnStatus" + i ];
			statusElement.NameText.text = currentStatus.Name;
			statusElement.HPText.text = currentStatus.HP;
			statusElement.SPText.text = currentStatus.SP;
			statusElement.LVText.text = currentStatus.LV;
		}
		// 初回処理 //////////////////////////////////////////////////
		var currentTurn = battleData.turn[ stage.turnNum ];
		// メッセージ反映
		this.TopIndex.Message.text = currentTurn.message;
		// ターンのカウントを増やす
		stage.turnNum++;
		
		// クリックイベントの設定（view全体に）
		this.TopIndex.onClick = function( e ){
			if( stage.isAnimate ){
				// アニメ中は動作しない。
			} else {
				// 現在のターン
				var currentTurn = battleData.turn[ stage.turnNum ];
				var nextTurn = battleData.turn[ stage.turnNum + 1 ];
				// modeによって表示分岐
				if( currentTurn.mode == "attack" ) {
					e.target.Message.text = stage.multiLineConvert( currentTurn.message );
					e.target[ "Enemy" + currentTurn.effect.eid ].gotoAndPlay( "defence" );			
					e.target[ "Slash" + currentTurn.effect.eid ].gotoAndPlay( "attack" );
					e.target.parent.gotoAndPlay( "attack" );
					// アニメ中フラグ ON
					stage.isAnimate = true;
				} else if( currentTurn.mode == "defence" ) {
					e.target.Message.text = stage.multiLineConvert( currentTurn.message );
					e.target[ "Enemy" + currentTurn.effect.eid ].gotoAndPlay( "attack" );		
					e.target.parent.gotoAndPlay( "defence" );
					// ダメージ反映
					var currentStatus = battleData.startStatus[ currentTurn.effect.id ];
					var statusElement = e.target[ "OwnStatus" + currentTurn.effect.id ];
					var afterHP = currentStatus.HP - currentTurn.effect.damage;
					statusElement.HPText.text = afterHP;
					// アニメ中フラグ ON
					stage.isAnimate = true;
				} else if( currentTurn.mode == "finish" ) {
					// アニメ中フラグ ON
					stage.isAnimate = true;
					// URLジャンプ
					window.open("createjs_battle_sample_viewport.html", "_self");
				}
			
				// ターンのカウントを増やす
				stage.turnNum++;
			}
		}
		
		// 複数行時のテキスト整形
		stage.multiLineConvert = function(str){
			var ret = "";
			var lineNum = 15;
			var count = 0;
			while( count < str.length - 1 ){
				var cutStr = str.substr(count,lineNum);
				var turnIndex = cutStr.indexOf("\n");
				if( turnIndex > -1 ){
					turnIndex += 1;
					ret += cutStr.substr(0,turnIndex);
					count += turnIndex;
				} else {
					ret += cutStr + "\n";
					count += lineNum;
				}
				
			}
			return ret;
		}
	}
	this.frame_35 = function() {
		this.stop();
	}
	this.frame_71 = function() {
		// アニメ中フラグ OFF
		stage.isAnimate = false;
		// 停止
		this.stop();
	}
	this.frame_92 = function() {
		// ターン情報
		// stage.turnNumすでに1進んでいる状態なので以下のようになる。
		var currentTurn = battleData.turn[ stage.turnNum - 1 ];
		var nextTurn = battleData.turn[ stage.turnNum ];
		// 死亡処理
		if( currentTurn.dead ){
			this.TopIndex[ "Enemy" + currentTurn.dead.eid ].gotoAndPlay( "dead" );
		}
		// 終了処理
		if( nextTurn.mode == "finish" ) {
			// 終了演出
			this.TopIndex.Message.text = nextTurn.message;
			// そのままfinishフレームへ移動
		} else {
			// アニメ中フラグ OFF
			stage.isAnimate = false;
			// 停止
			this.stop();
		}
	}
	this.frame_103 = function() {
		// アニメ中フラグ OFF
		stage.isAnimate = false;
		// 停止
		this.stop();
	}

	// actions tween:
	this.timeline.addTween(cjs.Tween.get(this).call(this.frame_0).wait(35).call(this.frame_35).wait(36).call(this.frame_71).wait(21).call(this.frame_92).wait(11).call(this.frame_103));

	// touchscreen
	this.touchscreen = new lib._00touchscreen();
	this.touchscreen.setTransform(161.5,445.5,1,1,0,0,0,104.5,14);
	this.touchscreen._off = true;

	this.timeline.addTween(cjs.Tween.get(this.touchscreen).wait(71).to({_off:false},0).to({_off:true},1).wait(20).to({_off:false},0).to({_off:true},1).wait(10).to({_off:false},0).wait(1));

	// win
	this.instance = new lib.win();
	this.instance.setTransform(0,200);

	this.timeline.addTween(cjs.Tween.get({}).to({state:[]}).to({state:[{t:this.instance}]},93).wait(11));

	// white
	this.instance_1 = new lib._00white();
	this.instance_1.setTransform(160,240,1,1,0,0,0,160,240);
	this.instance_1._off = true;

	this.timeline.addTween(cjs.Tween.get(this.instance_1).wait(17).to({_off:false},0).to({_off:true},2).wait(2).to({_off:false},0).to({_off:true},2).wait(61).to({_off:false},0).to({_off:true},2).wait(2).to({_off:false},0).to({_off:true},2).wait(14));

	// black
	this.instance_2 = new lib._00black();
	this.instance_2.setTransform(160,240,1,0.275,0,0,0,160,40);
	this.instance_2._off = true;

	this.timeline.addTween(cjs.Tween.get(this.instance_2).wait(24).to({_off:false},0).to({scaleY:6},5,cjs.Ease.get(1)).to({scaleY:1},5,cjs.Ease.get(-0.99)).to({_off:true},1).wait(69));

	// title
	this.instance_3 = new lib._00title();
	this.instance_3.setTransform(-159.9,240,1,1,0,0,0,160,40);
	this.instance_3._off = true;

	this.timeline.addTween(cjs.Tween.get(this.instance_3).wait(1).to({_off:false},0).to({x:160},5,cjs.Ease.get(1)).to({_off:true},23).wait(69));

	// tile
	this.instance_4 = new lib.green_tile();

	this.timeline.addTween(cjs.Tween.get({}).to({state:[{t:this.instance_4}]}).to({state:[]},29).to({state:[]},6).wait(69));

	// TopIndex
	this.TopIndex = new lib._00TopIndex();
	this.TopIndex.setTransform(160,240,1,1,0,0,0,160,240);

	this.timeline.addTween(cjs.Tween.get(this.TopIndex).wait(62).to({y:230},0).wait(2).to({y:240},0).wait(2).to({y:230},0).wait(2).to({y:240},0).wait(36));

}).prototype = p = new cjs.MovieClip();
p.nominalBounds = new cjs.Rectangle(0,0,320,480);


// symbols:
(lib.enemy = function() {
	this.initialize(img.enemy);
}).prototype = new cjs.Bitmap();
p.nominalBounds = new cjs.Rectangle(0,0,80,80);


(lib.green_tile = function() {
	this.initialize(img.green_tile);
}).prototype = new cjs.Bitmap();
p.nominalBounds = new cjs.Rectangle(0,0,320,480);


(lib.slash0 = function() {
	this.initialize(img.slash0);
}).prototype = new cjs.Bitmap();
p.nominalBounds = new cjs.Rectangle(0,0,80,80);


(lib.title = function() {
	this.initialize(img.title);
}).prototype = new cjs.Bitmap();
p.nominalBounds = new cjs.Rectangle(0,0,320,80);


(lib.win = function() {
	this.initialize(img.win);
}).prototype = new cjs.Bitmap();
p.nominalBounds = new cjs.Rectangle(0,0,320,80);


(lib._00white = function() {
	this.initialize();

	// レイヤー 1
	this.shape = new cjs.Shape();
	this.shape.graphics.f("#FFFFFF").s().p("EAZAglfMAAABK/Mgx/AAAMAAAhK/MAx/AAA").cp();
	this.shape.setTransform(160,240);

	this.addChild(this.shape);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,320,480);


(lib._00touchscreen = function() {
	this.initialize();

	// レイヤー 1
	this.text = new cjs.Text("TOUCH SCREEN", "24px MS PGothic", "#FFFFFF");
	this.text.textAlign = "center";
	this.text.lineHeight = 26;
	this.text.lineWidth = 205;
	this.text.setTransform(102.5,0);

	this.addChild(this.text);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,209,28.1);


(lib._00title = function() {
	this.initialize();

	// レイヤー 1
	this.instance = new lib.title();

	this.addChild(this.instance);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,320,80);


(lib._00slashbase = function() {
	this.initialize();

	// レイヤー 1
	this.instance_1 = new lib.slash0();

	this.addChild(this.instance_1);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,80,80);


(lib._00ownstatus = function() {
	this.initialize();

	// レイヤー 1
	this.LVText = new cjs.Text("0", "18px MS PGothic", "#FFFFFF");
	this.LVText.lineHeight = 20;
	this.LVText.lineWidth = 59;
	this.LVText.setTransform(0,90);

	this.SPText = new cjs.Text("0", "18px MS PGothic", "#FFFFFF");
	this.SPText.lineHeight = 20;
	this.SPText.lineWidth = 59;
	this.SPText.setTransform(0,60);

	this.HPText = new cjs.Text("0", "18px MS PGothic", "#FFFFFF");
	this.HPText.lineHeight = 20;
	this.HPText.lineWidth = 59;
	this.HPText.setTransform(0,30);

	this.NameText = new cjs.Text("主人公", "18px MS PGothic", "#FFFFFF");
	this.NameText.lineHeight = 20;
	this.NameText.lineWidth = 63;

	this.addChild(this.NameText,this.HPText,this.SPText,this.LVText);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,67,112);


(lib._00enemybase = function() {
	this.initialize();

	// レイヤー 1
	this.instance_2 = new lib.enemy();

	this.addChild(this.instance_2);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,80,80);


(lib._00dialog = function() {
	this.initialize();

	// レイヤー 1
	this.shape_1 = new cjs.Shape();
	this.shape_1.graphics.f().s("#FFFFFF").ss(5,1,1).p("AVPrFMgqdAAAQhkAAAABkIAATDQAABkBkAAMAqdAAAQBkAAAAhkIAAzDQAAhkhkAAIAAAA").cp();
	this.shape_1.setTransform(146,71);

	this.addChild(this.shape_1);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,292,142);


(lib._00black = function() {
	this.initialize();

	// レイヤー 1
	this.shape_2 = new cjs.Shape();
	this.shape_2.graphics.f("#000000").s().p("AZAGQMgx/AAAIAAsfMAx/AAAIAAMf").cp();
	this.shape_2.setTransform(160,40);

	this.addChild(this.shape_2);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,320,80);


(lib._00slash = function(mode,startPosition,loop) {
	this.initialize(mode,startPosition,loop,{attack:10},true);

	// timeline functions:
	this.frame_9 = function() {
		this.stop();
	}
	this.frame_39 = function() {
		this.stop();
	}

	// actions tween:
	this.timeline.addTween(cjs.Tween.get(this).wait(9).call(this.frame_9).wait(30).call(this.frame_39));

	// base
	this.instance_3 = new lib._00slashbase();
	this.instance_3.setTransform(120,-39.9,1,1,0,0,0,40,40);
	this.instance_3._off = true;

	this.timeline.addTween(cjs.Tween.get(this.instance_3).wait(13).to({_off:false},0).to({x:40,y:40},8,cjs.Ease.get(1)).to({_off:true},1).wait(18));

}).prototype = p = new cjs.MovieClip();
p.nominalBounds = new cjs.Rectangle(0,0,0,0);


(lib._00enemy = function(mode,startPosition,loop) {
	this.initialize(mode,startPosition,loop,{attack:9,defence:39,dead:66},true);

	// timeline functions:
	this.frame_8 = function() {
		this.stop();
	}
	this.frame_38 = function() {
		this.stop();
	}
	this.frame_65 = function() {
		this.stop();
	}
	this.frame_76 = function() {
		this.stop();
	}

	// actions tween:
	this.timeline.addTween(cjs.Tween.get(this).wait(8).call(this.frame_8).wait(30).call(this.frame_38).wait(27).call(this.frame_65).wait(11).call(this.frame_76));

	// レイヤー 1
	this.instance_4 = new lib._00enemybase();
	this.instance_4.setTransform(40,40,1,1,0,0,0,40,40);

	this.timeline.addTween(cjs.Tween.get(this.instance_4).wait(11).to({y:20},3,cjs.Ease.get(1)).wait(3).to({y:80},7,cjs.Ease.get(-0.99)).wait(2).to({y:40},0).wait(15).to({scaleX:0.8,scaleY:0.8},5,cjs.Ease.get(1)).to({scaleX:1,scaleY:1},3,cjs.Ease.get(1)).wait(17).to({alpha:0},4).to({_off:true},1).wait(6));

}).prototype = p = new cjs.MovieClip();
p.nominalBounds = new cjs.Rectangle(0,0,80,80);


(lib._00TopIndex = function() {
	this.initialize();

	// message
	this.Message = new cjs.Text("", "18px MS PGothic", "#FFFFFF");
	this.Message.lineHeight = 20;
	this.Message.lineWidth = 260;
	this.Message.setTransform(28,335.5);

	// slash2
	this.Slash2 = new lib._00slash();
	this.Slash2.setTransform(220,200);

	// slash1
	this.Slash1 = new lib._00slash();
	this.Slash1.setTransform(120,200);

	// slash0
	this.Slash0 = new lib._00slash();
	this.Slash0.setTransform(20,200);

	// enemy2
	this.Enemy2 = new lib._00enemy();
	this.Enemy2.setTransform(260,240,1,1,0,0,0,40,40);

	// enemy1
	this.Enemy1 = new lib._00enemy();
	this.Enemy1.setTransform(160,240,1,1,0,0,0,40,40);

	// enemy0
	this.Enemy0 = new lib._00enemy();
	this.Enemy0.setTransform(60,240,1,1,0,0,0,40,40);

	// 00 dialog
	this.OwnStatus2 = new lib._00ownstatus();
	this.OwnStatus2.setTransform(246.5,79.7,1,1,0,0,0,31.5,56);

	this.OwnStatus1 = new lib._00ownstatus();
	this.OwnStatus1.setTransform(176.5,79.7,1,1,0,0,0,31.5,56);

	this.OwnStatus0 = new lib._00ownstatus();
	this.OwnStatus0.setTransform(106.5,79.7,1,1,0,0,0,31.5,56);

	this.text_1 = new cjs.Text("LV:", "18px MS PGothic", "#FFFFFF");
	this.text_1.lineHeight = 20;
	this.text_1.setTransform(25,113.7);

	this.text_2 = new cjs.Text("SP:", "18px MS PGothic", "#FFFFFF");
	this.text_2.lineHeight = 20;
	this.text_2.setTransform(25,83.7);

	this.text_3 = new cjs.Text("HP:", "18px MS PGothic", "#FFFFFF");
	this.text_3.lineHeight = 20;
	this.text_3.setTransform(25,53.7);

	this.instance_5 = new lib._00dialog();
	this.instance_5.setTransform(159,395,1,1,0,0,0,146,71);

	// 00 dialog
	this.instance_6 = new lib._00dialog();
	this.instance_6.setTransform(159,85,1,1,0,0,0,146,71);

	// bg
	this.shape_3 = new cjs.Shape();
	this.shape_3.graphics.f("#000000").s().p("EAZAglfMAAABK/Mgx/AAAMAAAhK/MAx/AAA").cp();
	this.shape_3.setTransform(160,240);

	this.addChild(this.shape_3,this.instance_6,this.instance_5,this.text_3,this.text_2,this.text_1,this.OwnStatus0,this.OwnStatus1,this.OwnStatus2,this.Enemy0,this.Enemy1,this.Enemy2,this.Slash0,this.Slash1,this.Slash2,this.Message);
}).prototype = p = new cjs.Container();
p.nominalBounds = new cjs.Rectangle(0,0,320,480);

})(lib = lib||{}, images = images||{}, createjs = createjs||{});
var lib, images, createjs;